/* ****************************************************************************
 * Copyright: 2017-2025 RAYLASE GmbH
 * This source code is the proprietary confidential property of RAYLASE GmbH.
 * Reproduction, publication, or any form of distribution to
 * any party other than the licensee is strictly prohibited.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
 * IN THE SOFTWARE.
 */

#ifndef SPICE3_POWERCORRECTION_API_
#define SPICE3_POWERCORRECTION_API_

#include "rlTypes.h"

RL_C_API rlResult rlPowerCorrectionCreate(rlHandle handle, const rlOpticalParameters* parameters);
RL_C_API rlResult rlPowerCorrectionSet(rlHandle handle, const char* localFileName);
RL_C_API rlResult rlPowerCorrectionGet(rlHandle handle, const char* localFileName);
RL_C_API rlResult rlPowerCorrectionLoad(rlHandle handle);
RL_C_API rlResult rlPowerCorrectionStore(rlHandle handle);

RL_C_API rlResult rlPowerCorrectionChangeValue(rlHandle handle, rlPoint3D position, double factor);

RL_C_API rlResult rlPowerCorrectionGetOpticalParameters(rlHandle handle, rlOpticalParameters* parameters);

#endif // SPICE3_POWERCORRECTION_API_
